;ports
sLSB0     equ 00h
sMSB0     equ 01h
sX0       equ 02h
sY0       equ 03h
sMethod0  equ 04h
sLSB1     equ 05h
sMSB1     equ 06h
sX1       equ 07h
sY1       equ 08h
sMethod1  equ 09h
sLSB2     equ 0Ah
sMSB2     equ 0Bh
sX2       equ 0Ch
sY2       equ 0Dh
sMethod2  equ 0Eh
sLSB3     equ 0Fh
sMSB3     equ 10h
sX3       equ 11h
sY3       equ 12h
sMethod3  equ 13h
sLSB4     equ 14h
sMSB4     equ 15h
sX4       equ 16h
sY4       equ 17h
sMethod4  equ 18h
sLSB5     equ 19h
sMSB5     equ 1Ah
sX5       equ 1Bh
sY5       equ 1Ch
sMethod5  equ 1Dh
sLSB6     equ 1Eh
sMSB6     equ 1Fh
sX6       equ 20h
sY6       equ 21h
sMethod6  equ 22h
sLSB7     equ 23h
sMSB7     equ 24h
sX7       equ 25h
sY7       equ 26h
sMethod7  equ 27h
key0      equ 28h
key1      equ 29h
key2      equ 2Ah
key3      equ 2Bh
key4      equ 2Ch
key5      equ 2Dh
key6      equ 2Eh
indbyte   equ 2Fh
sMask     equ 30h
status    equ 31h     ;bit 7 set means turn the system off, bit 0 = LCD update

;RAM equates
stackptr  equ 32h
PClow     equ 33h+saveSScreen
PChigh    equ 34h+saveSScreen

stackbase equ 80h+saveSScreen

lcdupdatebit       equ 0
spriteupdatebit    equ 1


#define    lda(addr1  , addr2)     .db 0,addr1,addr2
#define    adda(addr1 , addr2)     .db 1,addr1,addr2
#define    adca(addr1 , addr2)     .db 2,addr1,addr2
#define    suba(addr1 , addr2)     .db 3,addr1,addr2
#define    sbca(addr1 , addr2)     .db 4,addr1,addr2
#define    xora(addr1 , addr2)     .db 5,addr1,addr2
#define    ora(addr1  , addr2)     .db 6,addr1,addr2
#define    anda(addr1 , addr2)     .db 7,addr1,addr2
#define    cpa(addr1  , addr2)     .db 8,addr1,addr2
#define    inc(addr)               .db 9,addr
#define    rotl(addr)              .db 10,addr
#define    shftl(addr)             .db 11,addr
#define    pusha(addr)             .db 12,addr
#define    pop(addr)               .db 13,addr
#define    inv(addr)               .db 14,addr
#define    ldira(addr,size)        .db 15,addr,size

#define    ldc(addr  , const)      .db 16,addr,const
#define    addc(addr , const)      .db 17,addr,const
#define    adcc(addr , const)      .db 18,addr,const
#define    subc(addr , const)      .db 19,addr,const
#define    sbcc(addr , const)      .db 20,addr,const
#define    xorc(addr , const)      .db 21,addr,const
#define    orc(addr  , const)      .db 22,addr,const
#define    andc(addr , const)      .db 23,addr,const
#define    cpc(addr  , const)      .db 24,addr,const
#define    dec(addr)               .db 25,addr
#define    rotr(addr)              .db 26,addr
#define    shftr(addr)             .db 27,addr
#define    pushc(const)            .db 28,const
#define    ex(addr1,addr2)         .db 29,addr1,addr2
#define    bits(addr,const)        .db 30,addr,const
#define    ldirc(addr,size)        .db 31,addr,size

#define    ret()                   .db 32
#define    setz()                  .db 33
#define    setc()                  .db 34
#define    togz()                  .db 35
#define    togc()                  .db 36
#define    jp1(Addr)               .db 37,Addr
#define    jp2(Addr)               .db 38,Addr
#define    jrf(offset)             .db 39,offset-1-$
#define    jrb(offset)             .db 40,1-offset+$
#define    call1(Addr)             .db 41,Addr
#define    call2(Addr)             .db 42,Addr
#define    callf(offset)           .db 43,offset-1-$
#define    callb(offset)           .db 44,1-offset+$

#define    ind1()                  .db 46
#define    ind2()                  .db 47

#define    ldac(addr1  , addr2)     .db 64+0,addr1,addr2
#define    addac(addr1 , addr2)     .db 64+1,addr1,addr2
#define    adcac(addr1 , addr2)     .db 64+2,addr1,addr2
#define    subac(addr1 , addr2)     .db 64+3,addr1,addr2
#define    sbcac(addr1 , addr2)     .db 64+4,addr1,addr2
#define    xorac(addr1 , addr2)     .db 64+5,addr1,addr2
#define    orac(addr1  , addr2)     .db 64+6,addr1,addr2
#define    andac(addr1 , addr2)     .db 64+7,addr1,addr2
#define    cpac(addr1  , addr2)     .db 64+8,addr1,addr2
#define    incc(addr)               .db 64+9,addr
#define    rotlc(addr)              .db 64+10,addr
#define    shftlc(addr)             .db 64+11,addr
#define    pushac(addr)             .db 64+12,addr
#define    popc(addr)               .db 64+13,addr
#define    invc(addr)               .db 64+14,addr
#define    ldirac(addr,size)        .db 64+15,addr,size

#define    ldcc(addr  , const)      .db 64+16,addr,const
#define    addcc(addr , const)      .db 64+17,addr,const
#define    adccc(addr , const)      .db 64+18,addr,const
#define    subcc(addr , const)      .db 64+19,addr,const
#define    sbccc(addr , const)      .db 64+20,addr,const
#define    xorcc(addr , const)      .db 64+21,addr,const
#define    orcc(addr  , const)      .db 64+22,addr,const
#define    andcc(addr , const)      .db 64+23,addr,const
#define    cpcc(addr  , const)      .db 64+24,addr,const
#define    decc(addr)               .db 64+25,addr
#define    rotrc(addr)              .db 64+26,addr
#define    shftrc(addr)             .db 64+27,addr
#define    pushcc(const)            .db 64+28,const
#define    exc(addr1,addr2)         .db 64+29,addr1,addr2
#define    bitsc(addr,const)        .db 64+30,addr,const
#define    ldircc(addr,size)        .db 64+31,addr,size

#define    retc()                   .db 64+32
#define    setzc()                  .db 64+33
#define    setcc()                  .db 64+34
#define    togzc()                  .db 64+35
#define    togcc()                  .db 64+36
#define    jp1c(Addr)               .db 64+37,Addr
#define    jp2c(Addr)               .db 64+38,Addr
#define    jrfc(offset)             .db 64+39,offset-1-$
#define    jrbc(offset)             .db 64+40,1-offset+$
#define    call1c(Addr)             .db 64+41,Addr
#define    call2c(Addr)             .db 64+42,Addr
#define    callfc(offset)           .db 64+43,offset-1-$
#define    callbc(offset)           .db 64+44,1-offset+$

#define    ind1c()                 .db 110
#define    ind2c()                 .db 111

#define    ldaz(addr1  , addr2)     .db 128+0,addr1,addr2
#define    addaz(addr1 , addr2)     .db 128+1,addr1,addr2
#define    adcaz(addr1 , addr2)     .db 128+2,addr1,addr2
#define    subaz(addr1 , addr2)     .db 128+3,addr1,addr2
#define    sbcaz(addr1 , addr2)     .db 128+4,addr1,addr2
#define    xoraz(addr1 , addr2)     .db 128+5,addr1,addr2
#define    oraz(addr1  , addr2)     .db 128+6,addr1,addr2
#define    andaz(addr1 , addr2)     .db 128+7,addr1,addr2
#define    cpaz(addr1  , addr2)     .db 128+8,addr1,addr2
#define    incz(addr)               .db 128+9,addr
#define    rotlz(addr)              .db 128+10,addr
#define    shftlz(addr)             .db 128+11,addr
#define    pushaz(addr)             .db 128+12,addr
#define    popz(addr)               .db 128+13,addr
#define    invz(addr)               .db 128+14,addr
#define    ldiraz(addr,size)        .db 128+15,addr,size

#define    ldcz(addr  , const)      .db 128+16,addr,const
#define    addcz(addr , const)      .db 128+17,addr,const
#define    adccz(addr , const)      .db 128+18,addr,const
#define    subcz(addr , const)      .db 128+19,addr,const
#define    sbccz(addr , const)      .db 128+20,addr,const
#define    xorcz(addr , const)      .db 128+21,addr,const
#define    orcz(addr  , const)      .db 128+22,addr,const
#define    andcz(addr , const)      .db 128+23,addr,const
#define    cpcz(addr  , const)      .db 128+24,addr,const
#define    decz(addr)               .db 128+25,addr
#define    rotrz(addr)              .db 128+26,addr
#define    shftrz(addr)             .db 128+27,addr
#define    pushcz(const)            .db 128+28,const
#define    exz(addr1,addr2)         .db 128+29,addr1,addr2
#define    bitsz(addr,const)        .db 128+30,addr,const
#define    ldircz(addr,size)        .db 128+31,addr,size

#define    retz()                   .db 128+32
#define    setzz()                  .db 128+33
#define    setcz()                  .db 128+34
#define    togzz()                  .db 128+35
#define    togcz()                  .db 128+36
#define    jp1z(Addr)               .db 128+37,Addr
#define    jp2z(Addr)               .db 128+38,Addr
#define    jrfz(offset)             .db 128+39,offset-1-$
#define    jrbz(offset)             .db 128+40,1-offset+$
#define    call1z(Addr)             .db 128+41,Addr
#define    call2z(Addr)             .db 128+42,Addr
#define    callfz(offset)           .db 128+43,offset-1-$
#define    callbz(offset)           .db 128+44,1-offset+$
#define    ind1z()                 .db 174
#define    ind2z()                 .db 175

jkDown     equ %11111110
jkRight    equ %11111101
jkLeft     equ %11111011
jkUp       equ %11110111
jkClear    equ %10111111

_FlashToRam2        equ 8054h

